""" A module to read a DART dump file.
"""

import os, sys, re

#from Euclid import Euclid_TC_codes, Euclid_TM_codes
import Euclid_TC_codes, Euclid_TM_codes

import EchoReader

""" This class provides an enum like constant for decoding the type of line read from the file. """
class LineType:
    TM, TC, Event, TM_PACKET, Empty, Err = range(6)

#logTime = ''

""" This class implements the Dump file reader. """
class TimeRangeEchoReader(EchoReader.EchoReader):


    def __init__(self, config_section):
        super(TimeRangeEchoReader, self).__init__(config_section)

#        self._filepath = ""
#        #self._fileId = 0
#        self._fileId = None
#        self._line = ""
#        self._error = 0
#        self._eof = 0
#        self._stop = 0
#        self._logTime = ''

        self.startDateTime = ''
        self.endDateTime = ''
#        self.in_range = False
        self.past_end = False

    def setStartDateTime(self, start):
        self.startDateTime = start
        self._logTime = start

    def setEndDateTime(self, end):
        self.endDateTime = end

    def is_in_range(self):
        early = self._logTime < self.startDateTime # T -> F -> F
        late = self._logTime > self.endDateTime    # F -> F -> T
        self.past_end = late
        ret = (early == late)
        return ret

    def reset(self):
        self._eof = 0
        self._stop = 0
        self.past_end = False

    def data_available(self):
        
        return (self._eof == 0) and (self._stop == 0) and (not self.past_end)
